%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MAT 259 Project 3                                             %
% Determine community structure for word network                %
% Author: Chantal Nguyen                                        %
% Supervisor: George Legrady                                    %
%                                                               %
% Reads in csv file containing sparse adjacency matrix          %
% Outputs csv file containing community number for each word    %
% Requires GenLouvain package available at                      %
% http://netwiki.amath.unc.edu/GenLouvain/GenLouvain            %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% read in csv file containing 3 columns: source node, target node, edge
% weight
sparse_adj = csvread('~/Documents/classes/MAT259/proj3/data/adjacency.csv');

% convert to graph object
A = zeros(max(sparse_adj(:,1)));
for i = 1:length(sparse_adj)
    A(sparse_adj(i,1),sparse_adj(i,2)) = sparse_adj(i,3);
end
G = graph(A);
A = adjacency(G,'weighted');

% do the community detection
resp = 1.2;
C = modularity(A,resp);
[S,Q,n_it]=iterated_genlouvain(C);

% write to csv file
csvwrite('~/Documents/classes/MAT259/proj3/data/communities.csv',S);